## wlmaker 0.6.1+git20250919+ds

=== CMakeLists.txt ===
# Copyright 2023 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Default arguments:
# cmake -DCMAKE_INSTALL_PREFIX:PATH=${HOME}/.local -Dconfig_DOXYGEN_CRITICAL=ON -Dconfig_WERROR=ON -B build
# CC=clang cmake -DCMAKE_INSTALL_PREFIX:PATH=${HOME}/.local -Dconfig_DOXYGEN_CRITICAL=ON -B build-clang

CMAKE_MINIMUM_REQUIRED(VERSION 3.13)
PROJECT(wlmaker VERSION 0.1
  DESCRIPTION "Wayland Maker - A Wayland compositor inspired by Window Maker"
  LANGUAGES C)

# Requires out-of-source builds.
FILE(TO_CMAKE_PATH "${PROJECT_BINARY_DIR}/CMakeLists.txt" LOCATION_PATH)
IF(EXISTS "${LOCATION_PATH}")
  MESSAGE(
    FATAL_ERROR
    "You cannot build into a source directory (containing a CMakeLists.txt file).\n"
    "Please make a build subdirectory, for example:\n"
    "cmake -B build\n"
    "(cd build && make)")
ENDIF()

# Defaults to /usr/local/lib for installation.
INCLUDE(GNUInstallDirs)
INCLUDE(CTest)

FIND_PACKAGE(PkgConfig REQUIRED)

PKG_CHECK_MODULES(CAIRO REQUIRED IMPORTED_TARGET cairo>=1.16.0)
PKG_CHECK_MODULES(XKBCOMMON REQUIRED IMPORTED_TARGET xkbcommon>=1.5.0)

# https://github.com/ianlancetaylor/libbacktrace.
# The REQUIRED arg is available only from cmake 3.28.
FIND_LIBRARY(LIBBACKTRACE backtrace)
IF(LIBBACKTRACE)
  MESSAGE(STATUS "Found libbacktrace: ${LIBBACKTRACE}")
ELSE()
  MESSAGE(STATUS "libbacktrace not found. Will compile without.")
ENDIF()

# Pruning includes.
FIND_PROGRAM(iwyu_executable NAMES include-what-you-use iwyu OPTIONAL)
IF(iwyu_executable)
  SET(iwyu_path_and_options
    ${iwyu_executable}
    -Xiwyu --error=1 -Xiwyu --transitive_includes_only -Xiwyu --mapping_file=${PROJECT_SOURCE_DIR}/iwyu-mappings.imp)
ENDIF(iwyu_executable)

FIND_PROGRAM(wmmenugen_executable NAMES wmmenugen OPTIONAL)
IF(wmmenugen_executable)
  MESSAGE(STATUS, "Found wmmenugen: ${wmmenugen_executable}")
ENDIF(wmmenugen_executable)

# Configuration. Remove CMakeCache.txt to rerun...
OPTION(config_DEBUG "Include debugging information" ON)
OPTION(config_OPTIM "Optimizations" OFF)
OPTION(config_DOXYGEN_CRITICAL "Whether to fail on doxygen warnings" OFF)
OPTION(config_WERROR "Make all compiler warnings into errors." OFF)

# Toplevel compile options, for GCC and clang.
IF(CMAKE_C_COMPILER_ID MATCHES "Clang|GNU")
  ADD_COMPILE_OPTIONS(-Wall -Wextra)
  IF(config_WERROR)
    ADD_COMPILE_OPTIONS(-Werror)
  ENDIF(config_WERROR)

  IF(config_DEBUG)
    ADD_COMPILE_OPTIONS(-ggdb -DDEBUG)
  ENDIF(config_DEBUG)

  IF(config_OPTIM)
    ADD_COMPILE_OPTIONS(-O2)
  ELSE (config_OPTIM)
    ADD_COMPILE_OPTIONS(-O0)
  ENDIF(config_OPTIM)

  # CMake provides absolute paths to GCC, hence the __FILE__ macro includes the
  # full path. This option resets it to a path relative to project source.
  ADD_COMPILE_OPTIONS(-fmacro-prefix-map=${PROJECT_SOURCE_DIR}=.)

ENDIF(CMAKE_C_COMPILER_ID MATCHES "Clang|GNU")
SET(CMAKE_C_STANDARD 11)

LIST(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

ADD_SUBDIRECTORY(apps)
ADD_SUBDIRECTORY(etc)
ADD_SUBDIRECTORY(icons)
ADD_SUBDIRECTORY(protocols)
ADD_SUBDIRECTORY(third_party/protocols)
ADD_SUBDIRECTORY(share)
ADD_SUBDIRECTORY(src)
ADD_SUBDIRECTORY(tests)

ADD_SUBDIRECTORY(doc)

# Adds submodules last, to permit checking on already-existing targets.
ADD_SUBDIRECTORY(submodules/libbase)

=== apps/CMakeLists.txt ===
# Copyright 2023 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

CMAKE_MINIMUM_REQUIRED(VERSION 3.13)

ADD_SUBDIRECTORY(libwlclient)
ADD_SUBDIRECTORY(primitives)

ADD_EXECUTABLE(example_toplevel example_toplevel.c)
TARGET_INCLUDE_DIRECTORIES(example_toplevel PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
TARGET_LINK_LIBRARIES(example_toplevel m libwlclient)

ADD_EXECUTABLE(wlmclock wlmclock.c)
TARGET_INCLUDE_DIRECTORIES(wlmclock PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
TARGET_LINK_LIBRARIES(wlmclock libwlclient primitives m)

ADD_EXECUTABLE(wlmeyes wlmeyes.c)
TARGET_INCLUDE_DIRECTORIES(wlmeyes PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
TARGET_LINK_LIBRARIES(wlmeyes m libwlclient)

INSTALL(TARGETS wlmclock DESTINATION bin)

IF(iwyu_path_and_options)
  SET_TARGET_PROPERTIES(
    example_toplevel PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
  SET_TARGET_PROPERTIES(
    wlmclock PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
  SET_TARGET_PROPERTIES(
    wlmeyes PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
ENDIF(iwyu_path_and_options)

=== dependencies/CMakeLists.txt ===
# Copyright 2023 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Default arguments:
# cmake -DCMAKE_INSTALL_PREFIX:PATH=${HOME}/.local -B build

CMAKE_MINIMUM_REQUIRED(VERSION 3.13)
PROJECT(wlmaker VERSION 0.1
  DESCRIPTION "Wayland Maker - Dependencies"
  LANGUAGES C)

# TODO(kaeser@gubbe.ch): Add a target for refreshing all submodules.
# See https://cliutils.gitlab.io/modern-cmake/chapters/projects/submodule.html

# If not found: Try 'pip3 install --user meson'
FIND_PROGRAM(MESON_EXECUTABLE NAMES meson REQUIRED)
FIND_PROGRAM(NINJA_EXECUTABLE NAMES ninja REQUIRED)
FIND_PACKAGE(PkgConfig REQUIRED)

# https://github.com/phkaeser/libbase
# Initialize: git submodule update --init --recursive --merge
# Checkout: git submodule update --checkout --recursive --merge
# Update: git submodule update --remote --merge
# Update: (cd libbase && git pull)
# ADD_SUBDIRECTORY(libbase)

# wlroots -- build and configure from the git submodule.
# Note: This will *NOT* automatically install the library.
INCLUDE(ExternalProject)

ExternalProject_Add(libbacktrace
  SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/libbacktrace"
  INSTALL_DIR ${CMAKE_INSTALL_PREFIX}
  CONFIGURE_COMMAND <SOURCE_DIR>/configure --prefix=<INSTALL_DIR> --datadir=<INSTALL_DIR>/share --datarootdir=<INSTALL_DIR>/share
  BUILD_COMMAND make
  INSTALL_COMMAND make install
)

# XWayland as optional dependency, configure wlroots accordingly.
PKG_CHECK_MODULES(XWAYLAND xwayland>=22.1.9)
IF(XWAYLAND_FOUND)
  SET(WLROOTS_XWAYLAND "-Dxwayland=enabled")
ELSE(XWAYLAND_FOUND)
  SET(WLROOTS_XWAYLAND  "-Dxwayland=disabled")
ENDIF(XWAYLAND_FOUND)

ExternalProject_Add(wlroots
  SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/wlroots"
  INSTALL_DIR ${CMAKE_INSTALL_PREFIX}
  CONFIGURE_COMMAND ${MESON_EXECUTABLE} --prefix=<INSTALL_DIR> <BINARY_DIR> <SOURCE_DIR> -Dexamples=true -Dbackends=drm,libinput,x11 ${WLROOTS_XWAYLAND}
  BUILD_COMMAND ${NINJA_EXECUTABLE} -C <BINARY_DIR>
  INSTALL_COMMAND ${NINJA_EXECUTABLE} -C <BINARY_DIR> install
)

=== doc/CMakeLists.txt ===
# Copyright 2023 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

CMAKE_MINIMUM_REQUIRED(VERSION 3.13)

FIND_PACKAGE(Doxygen)
IF(DOXYGEN_FOUND)

  FIND_FILE(PLANTUML_JAR
    NAMES plantuml.jar
    HINTS ENV{PLANTUML_JAR_PATH}
    PATHS
    /usr/global/share/java/plantuml/
    /usr/local/share/java/plantuml/
    /usr/share/java/
    /usr/local/share/java/
    /usr/share/plantuml/)
  IF(PLANTUML_JAR)
    SET(DOXYGEN_PLANTUML_JAR_FILE ${PLANTUML_JAR})
  ELSE()
    SET(DOXYGEN_PLANTUML_JAR_FILE "")
    MESSAGE(
      NOTICE
      "Did not find plantuml.jar -- Will not generate class diagrams.")
  ENDIF(PLANTUML_JAR)

  IF(config_DOXYGEN_CRITICAL)
    SET(DOXYGEN_WARN_AS_ERROR "YES")
  ELSE(config_DOXYGEN_CRITICAL)
    SET(DOXYGEN_WARN_AS_ERROR "NO")
  ENDIF(config_DOXYGEN_CRITICAL)

  # set input and output files
  SET(DOXYGEN_IN ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in)
  SET(DOXYGEN_OUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

  # request to configure the file
  CONFIGURE_FILE(${DOXYGEN_IN} ${DOXYGEN_OUT} @ONLY)
  MESSAGE(NOTICE "Doxygen available, adding 'doc' target.")

  ADD_CUSTOM_TARGET(
    doc
    COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_OUT}
    DEPENDS ${DOXYGEN_OUT} ${PROJECT_BINARY_DIR}/etc/root-menu-debian.plist
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating API documentation with Doxygen."
    VERBATIM)

  FILE(
    COPY ${PROJECT_SOURCE_DIR}/tests/data/toolkit/primitive_close_icon.png
    DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/html)
  FILE(
    COPY ${PROJECT_SOURCE_DIR}/tests/data/toolkit/primitive_minimize_icon.png
    DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/html)

ELSE()
  MESSAGE(NOTICE "Doxygen not found. Not adding 'doc' target to generate API documentation.")
ENDIF(DOXYGEN_FOUND)

=== etc/CMakeLists.txt ===
# Copyright 2023 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

CMAKE_MINIMUM_REQUIRED(VERSION 3.13)
INCLUDE(EmbedBinary)

EmbedBinary_ADD_LIBRARY(
  embedded_root_menu
  "root_menu"
  "${CMAKE_CURRENT_SOURCE_DIR}/root-menu.plist")

EmbedBinary_ADD_LIBRARY(
  embedded_style
  "style"
  "${CMAKE_CURRENT_SOURCE_DIR}/style.plist")

EmbedBinary_ADD_LIBRARY(
  embedded_configuration
  "default_configuration"
  "${CMAKE_CURRENT_SOURCE_DIR}/wlmaker.plist")

EmbedBinary_ADD_LIBRARY(
  embedded_state
  "default_state"
  "${CMAKE_CURRENT_SOURCE_DIR}/wlmaker-state.plist")

# Found in Debian's gnustep-base-runtime. Using to keep plist format consistent
# with what GNUstep expects. Optional.
FIND_PROGRAM(PLDES pldes)
IF(PLDES)
  MESSAGE("Found ${PLDES}. Adding consistency tests for GNUstep plist syntax.")

  # Sadly, the gnustep-base plist utilies don't return EXIT_FAILURE upon
  # parsing an invalid plist file. But eg. `pldes` reports the parsing error,
  # so we capture this as a failure.
  SET(pldes_failure_regex ".*at\ line.*char")

  ADD_TEST(
    NAME root_menu_plist_test
    COMMAND pldes "${CMAKE_CURRENT_SOURCE_DIR}/root-menu.plist")
  SET_PROPERTY(
    TEST root_menu_plist_test
    PROPERTY FAIL_REGULAR_EXPRESSION "${pldes_failure_regex}")

  ADD_TEST(
    NAME style_default_plist_test
    COMMAND pldes "${CMAKE_CURRENT_SOURCE_DIR}/style.plist")
  SET_PROPERTY(
    TEST style_default_plist_test
    PROPERTY FAIL_REGULAR_EXPRESSION "${pldes_failure_regex}")

  ADD_TEST(
    NAME style_debian_plist_test
    COMMAND pldes "${CMAKE_CURRENT_SOURCE_DIR}/style-debian.plist")
  SET_PROPERTY(
    TEST style_debian_plist_test
    PROPERTY FAIL_REGULAR_EXPRESSION "${pldes_failure_regex}")

  ADD_TEST(
    NAME wlmaker_plist_test
    COMMAND pldes "${CMAKE_CURRENT_SOURCE_DIR}/wlmaker.plist")
  SET_PROPERTY(
    TEST wlmaker_plist_test
    PROPERTY FAIL_REGULAR_EXPRESSION "${pldes_failure_regex}")

  ADD_TEST(
    NAME wlmaker_example_plist_test
    COMMAND pldes "${CMAKE_CURRENT_SOURCE_DIR}/wlmaker-example.plist")
  SET_PROPERTY(
    TEST wlmaker_example_plist_test
    PROPERTY FAIL_REGULAR_EXPRESSION "${pldes_failure_regex}")

  ADD_TEST(
    NAME wlmaker_home_plist_test
    COMMAND pldes "${CMAKE_CURRENT_SOURCE_DIR}/wlmaker-home.plist")
  SET_PROPERTY(
    TEST wlmaker_home_plist_test
    PROPERTY FAIL_REGULAR_EXPRESSION "${pldes_failure_regex}")

  ADD_TEST(
    NAME wlmaker_state_plist_test
    COMMAND pldes "${CMAKE_CURRENT_SOURCE_DIR}/wlmaker-state.plist")
  SET_PROPERTY(
    TEST wlmaker_state_plist_test
    PROPERTY FAIL_REGULAR_EXPRESSION "${pldes_failure_regex}")

ENDIF(PLDES)

INSTALL(
  FILES
  root-menu.plist
  style.plist
  wlmaker-state.plist
  wlmaker.plist
  DESTINATION share/wlmaker)

IF(wmmenugen_executable)
  CONFIGURE_FILE(
    ${CMAKE_CURRENT_SOURCE_DIR}/root-menu-debian.plist.in
    ${CMAKE_CURRENT_BINARY_DIR}/root-menu-debian.plist
    @ONLY)
  INSTALL(
    FILES
    ${CMAKE_CURRENT_BINARY_DIR}/root-menu-debian.plist
    DESTINATION share/wlmaker)
ENDIF(wmmenugen_executable)

=== protocols/CMakeLists.txt ===
# Copyright 2023 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

CMAKE_MINIMUM_REQUIRED(VERSION 3.13)

PKG_CHECK_MODULES(WAYLAND_PROTOCOLS REQUIRED IMPORTED_TARGET wayland-protocols>=1.32)
PKG_CHECK_MODULES(WAYLAND_SERVER REQUIRED IMPORTED_TARGET wayland-server>=1.22.0)

PKG_GET_VARIABLE(WAYLAND_PROTOCOL_DIR wayland-protocols pkgdatadir)

INCLUDE(WaylandProtocol)

SET(SOURCES)
WaylandProtocol_ADD(
  SOURCES
  BASE_NAME wlmaker-icon-unstable-v1
  PROTOCOL_FILE wlmaker-icon-unstable-v1.xml
  SIDE server)

WaylandProtocol_ADD(
  SOURCES
  BASE_NAME ext-input-observation-v1
  PROTOCOL_FILE ext-input-observation-v1.xml
  SIDE server)

PKG_GET_VARIABLE(WAYLAND_PROTOCOLDIR wayland-protocols pkgdatadir)
# Needing XDG Shell, since the toplevel icon protocol refers to it.
WaylandProtocol_ADD(
  SOURCES
  BASE_NAME xdg-shell
  PROTOCOL_FILE "${WAYLAND_PROTOCOLDIR}/stable/xdg-shell/xdg-shell.xml"
  SIDE server)

ADD_LIBRARY(wlmaker_protocols STATIC)
TARGET_SOURCES(
  wlmaker_protocols PRIVATE
  ${SOURCES})

TARGET_COMPILE_OPTIONS(
  wlmaker_protocols PRIVATE
  ${WAYLAND_SERVER_CFLAGS}
  ${WAYLAND_SERVER_CFLAGS_OTHER}
  ${WAYLAND_PROTOCOLS_CFLAGS}
  ${WAYLAND_PROTOCOLS_CFLAGS_OTHER})

=== share/CMakeLists.txt ===
# Copyright 2024 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

CMAKE_MINIMUM_REQUIRED(VERSION 3.13)

CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/wlmaker.desktop.in
  ${CMAKE_CURRENT_BINARY_DIR}/wlmaker.desktop
  @ONLY)
INSTALL(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/wlmaker.desktop
  TYPE DATA)

CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/wlmclock.desktop.in
  ${CMAKE_CURRENT_BINARY_DIR}/wlmclock.desktop
  @ONLY)
INSTALL(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/wlmclock.desktop
  TYPE DATA)

=== src/CMakeLists.txt ===
# Copyright 2023 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

CMAKE_MINIMUM_REQUIRED(VERSION 3.13)

# Further dependency versions, as submodules:
# * drm at libdrm-2.4.117
# * hwdata at v0.371
# * libdisplay-info at 0.2.0
# * pixman at pixman-0.43.0

PKG_CHECK_MODULES(WAYLAND_SERVER REQUIRED IMPORTED_TARGET wayland-server>=1.22.0)
# We build for wlroots 0.19 or 0.18.
PKG_CHECK_MODULES(WLROOTS IMPORTED_TARGET wlroots-0.19>=0.19)
IF(NOT WLROOTS_FOUND)
  PKG_CHECK_MODULES(WLROOTS REQUIRED IMPORTED_TARGET wlroots-0.18>=0.18)
ENDIF(NOT WLROOTS_FOUND)
PKG_CHECK_MODULES(XCB REQUIRED IMPORTED_TARGET xcb>=1.15)
# XWayland considered optional.
PKG_CHECK_MODULES(XWAYLAND xwayland>=22.1.9)

ADD_SUBDIRECTORY(backend)
ADD_SUBDIRECTORY(toolkit)

SET(PUBLIC_HEADER_FILES
  action.h
  action_item.h
  background.h
  backtrace.h
  clip.h
  config.h
  corner.h
  cursor.h
  dock.h
  icon_manager.h
  idle.h
  input_observation.h
  keyboard.h
  launcher.h
  layer_panel.h
  layer_shell.h
  lock_mgr.h
  root_menu.h
  server.h
  subprocess_monitor.h
  task_list.h
  tl_menu.h
  xdg_decoration.h
  xdg_popup.h
  xdg_shell.h
  xdg_toplevel.h
  xwl.h
  xwl_content.h
  xwl_popup.h
  xwl_toplevel.h)

ADD_LIBRARY(wlmaker_lib STATIC)
TARGET_SOURCES(wlmaker_lib PRIVATE
  action.c
  action_item.c
  background.c
  backtrace.c
  clip.c
  config.c
  corner.c
  cursor.c
  dock.c
  icon_manager.c
  idle.c
  input_observation.c
  keyboard.c
  launcher.c
  layer_panel.c
  layer_shell.c
  lock_mgr.c
  root_menu.c
  server.c
  subprocess_monitor.c
  task_list.c
  tl_menu.c
  x11_cursor.xpm
  xdg_decoration.c
  xdg_popup.c
  xdg_shell.c
  xdg_toplevel.c
  xwl.c
  xwl_content.c
  xwl_popup.c
  xwl_toplevel.c
)
SET_TARGET_PROPERTIES(
  wlmaker_lib PROPERTIES
  VERSION 1.0
  PUBLIC_HEADER "${PUBLIC_HEADER_FILES}")
IF(iwyu_path_and_options)
  SET_TARGET_PROPERTIES(
    wlmaker_lib PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
ENDIF(iwyu_path_and_options)

ADD_DEPENDENCIES(
  wlmaker_lib
  backend
  embedded_configuration
  embedded_root_menu
  embedded_state
  embedded_style
  libbase
  libbase_plist
  protocol_headers
  toolkit
  wlmaker_lib)

TARGET_LINK_LIBRARIES(
  wlmaker_lib
  backend
  embedded_configuration
  embedded_root_menu
  embedded_state
  embedded_style
  libbase
  libbase_plist
  toolkit
  wlmaker_protocols
  PkgConfig::CAIRO
  PkgConfig::WAYLAND_SERVER
  PkgConfig::WLROOTS
  PkgConfig::XCB
  PkgConfig::XKBCOMMON)
TARGET_INCLUDE_DIRECTORIES(
  wlmaker_lib PUBLIC
  # Keep wlroots first -- multiple versions may interfere (#117).
  ${WLROOTS_INCLUDE_DIRS}
  ${PROJECT_SOURCE_DIR}/include
  ${PROJECT_BINARY_DIR}/third_party/protocols
  ${PROJECT_BINARY_DIR}/protocols
  ${CAIRO_INCLUDE_DIRS}
  ${WAYLAND_SERVER_INCLUDE_DIRS}
  ${XCB_INCLUDE_DIRS}
  ${XKBCOMMON_INCLUDE_DIRS}
)
TARGET_COMPILE_DEFINITIONS(
  wlmaker_lib PRIVATE
  WLMAKER_ICON_DATA_DIR="${CMAKE_INSTALL_FULL_DATAROOTDIR}/icons/wlmaker")
TARGET_COMPILE_DEFINITIONS(
  wlmaker_lib PRIVATE WLMAKER_SOURCE_DIR="${PROJECT_SOURCE_DIR}")
TARGET_COMPILE_DEFINITIONS(
  wlmaker_lib PRIVATE WLMAKER_BINARY_DIR="${PROJECT_BINARY_DIR}")
IF(wmmenugen_executable)
  TARGET_COMPILE_DEFINITIONS(
    wlmaker_lib PRIVATE WLMAKER_WMMENUGEN_PATH="${wmmenugen_executable}")
ENDIF(wmmenugen_executable)
IF(XWAYLAND_FOUND)
  TARGET_COMPILE_DEFINITIONS(wlmaker_lib PUBLIC WLMAKER_HAVE_XWAYLAND)
ENDIF(XWAYLAND_FOUND)

ADD_EXECUTABLE(wlmaker wlmaker.c)
ADD_DEPENDENCIES(wlmaker wlmaker_lib)
TARGET_COMPILE_OPTIONS(
  wlmaker PRIVATE
  ${WAYLAND_SERVER_CFLAGS}
  ${WAYLAND_SERVER_CFLAGS_OTHER})
TARGET_LINK_LIBRARIES(wlmaker PRIVATE libbase libbase_plist wlmaker_lib)
IF(LIBBACKTRACE)
  TARGET_COMPILE_DEFINITIONS(wlmaker_lib PRIVATE WLMAKER_HAVE_LIBBACKTRACE)
  TARGET_LINK_LIBRARIES(wlmaker PRIVATE ${LIBBACKTRACE})
ENDIF()
IF(iwyu_path_and_options)
  SET_TARGET_PROPERTIES(
    wlmaker PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
ENDIF(iwyu_path_and_options)

INSTALL(TARGETS wlmaker DESTINATION bin)

=== apps/libwlclient/CMakeLists.txt ===
# Copyright 2023 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

CMAKE_MINIMUM_REQUIRED(VERSION 3.13)
INCLUDE(WaylandProtocol)

PKG_CHECK_MODULES(WAYLAND_CLIENT REQUIRED IMPORTED_TARGET wayland-client>=1.22.0)
PKG_CHECK_MODULES(WAYLAND_PROTOCOLS REQUIRED IMPORTED_TARGET wayland-protocols>=1.32)

PKG_GET_VARIABLE(WAYLAND_PROTOCOL_DIR wayland-protocols pkgdatadir)

ADD_LIBRARY(libwlclient STATIC)

SET(PUBLIC_HEADER_FILES
  dblbuf.h
  icon.h
  libwlclient.h
  xdg_toplevel.h
)
SET_TARGET_PROPERTIES(
  libwlclient PROPERTIES
  VERSION 1.0
  PUBLIC_HEADER "${PUBLIC_HEADER_FILES}")

SET(SOURCES
  client.c
  dblbuf.c
  icon.c
  xdg_toplevel.c
)
WaylandProtocol_ADD(
  SOURCES
  BASE_NAME xdg-decoration
  PROTOCOL_FILE "${WAYLAND_PROTOCOL_DIR}/unstable/xdg-decoration/xdg-decoration-unstable-v1.xml"
  SIDE client)
WaylandProtocol_ADD(
  SOURCES
  BASE_NAME xdg-shell
  PROTOCOL_FILE "${WAYLAND_PROTOCOL_DIR}/stable/xdg-shell/xdg-shell.xml"
  SIDE client)
WaylandProtocol_ADD(
  SOURCES
  BASE_NAME wlmaker-icon-unstable-v1
  PROTOCOL_FILE "${PROJECT_SOURCE_DIR}/protocols/wlmaker-icon-unstable-v1.xml"
  SIDE client)
WaylandProtocol_ADD(
  SOURCES
  BASE_NAME ext-input-observation-v1
  PROTOCOL_FILE "${PROJECT_SOURCE_DIR}/protocols/ext-input-observation-v1.xml"
  SIDE client)

TARGET_SOURCES(libwlclient PRIVATE ${SOURCES})

TARGET_INCLUDE_DIRECTORIES(
  libwlclient PRIVATE
  ${WAYLAND_CLIENT_INCLUDE_DIRS}
  ${XKBCOMMON_INCLUDE_DIRS}
  ${CMAKE_CURRENT_BINARY_DIR})
TARGET_LINK_LIBRARIES(
  libwlclient
  libbase
  PkgConfig::WAYLAND_CLIENT
  PkgConfig::XKBCOMMON)
INCLUDE(CheckSymbolExists)
CHECK_SYMBOL_EXISTS(signalfd "sys/signalfd.h" HAVE_SIGNALFD)
IF(NOT HAVE_SIGNALFD)
  PKG_CHECK_MODULES(EPOLL REQUIRED IMPORTED_TARGET epoll-shim)
  TARGET_LINK_LIBRARIES(libwlclient PkgConfig::EPOLL)
ENDIF()

IF(iwyu_path_and_options)
  SET_TARGET_PROPERTIES(
    libwlclient PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
ENDIF(iwyu_path_and_options)

=== apps/primitives/CMakeLists.txt ===
# Copyright 2023 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

CMAKE_MINIMUM_REQUIRED(VERSION 3.13)

ADD_LIBRARY(primitives STATIC)
TARGET_SOURCES(
  primitives PRIVATE
  primitives.h primitives.c
  segment_display.h segment_display.c)
TARGET_INCLUDE_DIRECTORIES(
  primitives PRIVATE)
TARGET_LINK_LIBRARIES(
  primitives
  libbase)

ADD_EXECUTABLE(segment_display_test
  segment_display_test.c
  segment_display.c
  segment_display.h)
TARGET_COMPILE_DEFINITIONS(
  segment_display_test PRIVATE
  TEST_DATA_DIR="${CMAKE_CURRENT_SOURCE_DIR}")
TARGET_INCLUDE_DIRECTORIES(
  segment_display_test PRIVATE
  ${CAIRO_INCLUDE_DIRS})
TARGET_LINK_LIBRARIES(
  segment_display_test PRIVATE
  libbase
  PkgConfig::CAIRO)
ADD_TEST(
  NAME segment_display_test
  COMMAND segment_display_test)

IF(iwyu_path_and_options)
  SET_TARGET_PROPERTIES(
    primitives PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
  SET_TARGET_PROPERTIES(
    segment_display_test PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
ENDIF(iwyu_path_and_options)

=== src/backend/CMakeLists.txt ===
# Copyright 2025 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

CMAKE_MINIMUM_REQUIRED(VERSION 3.13)

SET(PUBLIC_HEADER_FILES
  backend.h
  output.h
  output_config.h
  output_manager.h)

ADD_LIBRARY(backend STATIC
  backend.c
  output.c
  output_config.c
  output_manager.c)

TARGET_INCLUDE_DIRECTORIES(
  backend
  PUBLIC
  ${PROJECT_SOURCE_DIR}/include
  PRIVATE
  ${WAYLAND_SERVER_INCLUDE_DIRS}
  ${WLROOTS_INCLUDE_DIRS}
  ${PROJECT_SOURCE_DIR}/include
)
TARGET_INCLUDE_DIRECTORIES(
  backend
  PRIVATE
  ${PROJECT_SOURCE_DIR}/include/backend
)

SET_TARGET_PROPERTIES(
  backend PROPERTIES
  VERSION 1.0
  PUBLIC_HEADER "${PUBLIC_HEADER_FILES}"
)

TARGET_COMPILE_OPTIONS(
  backend PRIVATE
  ${WAYLAND_SERVER_CFLAGS}
  ${WAYLAND_SERVER_CFLAGS_OTHER}
)

TARGET_LINK_LIBRARIES(
  backend
  PUBLIC
  libbase
  libbase_plist
  PkgConfig::WAYLAND_SERVER
  PRIVATE
  toolkit
  PkgConfig::WLROOTS)

IF(iwyu_path_and_options)
  SET_TARGET_PROPERTIES(
    backend PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
ENDIF(iwyu_path_and_options)

=== src/toolkit/CMakeLists.txt ===
# Copyright 2023 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

CMAKE_MINIMUM_REQUIRED(VERSION 3.13)

SET(PUBLIC_HEADER_FILES
  bordered.h
  box.h
  buffer.h
  button.h
  container.h
  content.h
  dock.h
  element.h
  fsm.h
  gfxbuf.h
  image.h
  input.h
  layer.h
  menu.h
  menu_item.h
  pane.h
  panel.h
  popup.h
  primitives.h
  rectangle.h
  resizebar.h
  resizebar_area.h
  root.h
  style.h
  surface.h
  test.h
  tile.h
  titlebar.h
  titlebar_button.h
  titlebar_title.h
  toolkit.h
  util.h
  window.h
  workspace.h
)

ADD_LIBRARY(toolkit STATIC)
TARGET_SOURCES(toolkit PRIVATE
  bordered.c
  box.c
  buffer.c
  button.c
  container.c
  content.c
  dock.c
  element.c
  fsm.c
  gfxbuf.c
  image.c
  input.c
  layer.c
  menu.c
  menu_item.c
  pane.c
  panel.c
  popup.c
  primitives.c
  rectangle.c
  resizebar.c
  resizebar_area.c
  root.c
  style.c
  surface.c
  test.c
  tile.c
  titlebar.c
  titlebar_button.c
  titlebar_title.c
  util.c
  window.c
  workspace.c
)
TARGET_INCLUDE_DIRECTORIES(
  toolkit PUBLIC
  ${WLROOTS_INCLUDE_DIRS}
  ${CAIRO_INCLUDE_DIRS}
  ${PROJECT_SOURCE_DIR}/include
)
TARGET_INCLUDE_DIRECTORIES(
  toolkit PRIVATE
  ${PROJECT_SOURCE_DIR}/include/toolkit
)
SET_TARGET_PROPERTIES(
  toolkit PROPERTIES
  VERSION 1.0
  PUBLIC_HEADER "${PUBLIC_HEADER_FILES}"
)

TARGET_COMPILE_OPTIONS(
  toolkit PRIVATE
  ${WAYLAND_SERVER_CFLAGS}
  ${WAYLAND_SERVER_CFLAGS_OTHER}
)

TARGET_LINK_LIBRARIES(
  toolkit
  PUBLIC libbase PkgConfig::CAIRO PkgConfig::WLROOTS
  PRIVATE PkgConfig::WAYLAND_SERVER
)

IF(iwyu_path_and_options)
  SET_TARGET_PROPERTIES(
    toolkit PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
ENDIF(iwyu_path_and_options)

=== debian/changelog ===
wlmaker (0.6.1+git20250919+ds-2) unstable; urgency=medium

  * d/rules: drop wlmclock.desktop install, move it to d/install.
  * d/patches/nextstep-colors: added patch for consistent look.

 -- Alex Myczko <tar@debian.org>  Tue, 23 Sep 2025 09:11:27 +0200

wlmaker (0.6.1+git20250919+ds-1) unstable; urgency=medium

  * d/control: drop libwlroots-0.18-dev from build-depends. (Closes: #1111150)

 -- Alex Myczko <tar@debian.org>  Fri, 19 Sep 2025 11:14:29 +0200

=== debian/control ===
Source: wlmaker
Section: gnustep
Priority: optional
Maintainer: Debian GNUstep maintainers <pkg-gnustep-maintainers@lists.alioth.debian.org>
Uploaders: Alex Myczko <tar@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 bison,
 cmake,
 flex,
 libwayland-dev,
 libcairo2-dev,
 wayland-protocols,
 libwlroots-0.19-dev,
 libncurses-dev,
# plantuml,
 libwayland-bin,
Standards-Version: 4.7.2
Homepage: https://github.com/phkaeser/wlmaker
Vcs-Browser: https://salsa.debian.org/gnustep-team/wlmaker
Vcs-Git: https://salsa.debian.org/gnustep-team/wlmaker.git

Package: wlmaker
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 foot,
 swaylock,
 wmaker,
 wdisplays,
Description: Wayland compositor inspired by Window Maker
 This is a Wayland compositor inspired by Window Maker.
  - Compositor for windows in stacking mode.
  - Supports multiple workspaces.
  - Appearance inspired by Window Maker, following the look and feel of
    NeXTSTEP.
  - Easy to use, lightweight, low gimmicks and fast.
  - Dock and clip, to be extended for dockable apps.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# See FEATURE AREAS in dpkg-buildflags(1).
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_install:
	dh_install
#	rm debian/wlmaker/usr/bin/wrap-wlmaker.sh
	rm debian/wlmaker/usr/share/wlmaker.desktop
	rm debian/wlmaker/usr/share/wlmclock.desktop
#	mkdir -p debian/wlmaker/usr/share/applications
#	mv debian/wlmaker/usr/share/wlmclock.desktop debian/wlmaker/usr/share/applications/wlmclock.desktop

override_dh_auto_test:
	@echo no thanks

## wlmaker 0.6.2

=== submodules/libbase/src/CMakeLists.txt ===
# Copyright 2025 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

SET(PUBLIC_HEADER_FILES
  arg.h
  assert.h
  atomic.h
  avltree.h
  c2x_compat.h
  def.h
  dequeue.h
  dllist.h
  dynbuf.h
  file.h
  gfxbuf.h
  gfxbuf_xpm.h
  libbase.h
  log.h
  log_wrappers.h
  ptr_set.h
  ptr_stack.h
  ptr_vector.h
  sock.h
  strutil.h
  subprocess.h
  test.h
  thread.h
  time.h
  vector.h)

SET(SOURCES
  arg.c
  atomic.c
  avltree.c
  c2x_compat.c
  dequeue.c
  dllist.c
  dynbuf.c
  file.c
  gfxbuf.c
  gfxbuf_xpm.c
  log.c
  ptr_set.c
  ptr_stack.c
  ptr_vector.c
  sock.c
  strutil.c
  subprocess.c
  test.c
  thread.c
  time.c)

ADD_LIBRARY(libbase STATIC)
TARGET_SOURCES(libbase PRIVATE ${SOURCES})
TARGET_INCLUDE_DIRECTORIES(
  libbase
  PUBLIC
  $<INSTALL_INTERFACE:include>
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>)
TARGET_INCLUDE_DIRECTORIES(libbase PRIVATE ${CURSES_INCLUDE_DIRS})
TARGET_LINK_LIBRARIES(libbase PRIVATE ${CURSES_LIBRARIES})
SET_TARGET_PROPERTIES(
  libbase PROPERTIES
  VERSION 1.0
  PUBLIC_HEADER "${PUBLIC_HEADER_FILES}"
)

IF(iwyu_path_and_options)
  SET_TARGET_PROPERTIES(
    libbase PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
ENDIF(iwyu_path_and_options)

IF(CAIRO_FOUND)
  TARGET_COMPILE_DEFINITIONS(libbase PUBLIC HAVE_CAIRO)
  TARGET_INCLUDE_DIRECTORIES(libbase PUBLIC ${CAIRO_INCLUDE_DIRS})
  TARGET_LINK_LIBRARIES(libbase PUBLIC PkgConfig::CAIRO)
ENDIF(CAIRO_FOUND)

# Add 'install' target, but only if we're the toplevel project.
IF(CMAKE_PROJECT_NAME STREQUAL libbase)
  INSTALL(
    TARGETS libbase
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/libbase")
ENDIF()

=== submodules/libbase/tools/CMakeLists.txt ===
# Copyright 2025 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

ADD_EXECUTABLE(plist_parse plist_parse.c)
TARGET_LINK_LIBRARIES(plist_parse libbase libbase_plist)
TARGET_INCLUDE_DIRECTORIES(plist_parse PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/)

IF(iwyu_path_and_options)
  SET_TARGET_PROPERTIES(
    plist_parse PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
ENDIF(iwyu_path_and_options)

# Add 'install' target, but only if we're the toplevel project.
IF(CMAKE_PROJECT_NAME STREQUAL libbase)
  INSTALL(
    TARGETS plist_parse
    DESTINATION ${CMAKE_INSTALL_BINDIR})
ENDIF()

=== debian/changelog ===
wlmaker (0.6.2-2) unstable; urgency=medium

  * d/control: only use libwlroots-0.18-dev. (Closes: #1121292)

 -- Alex Myczko <tar@debian.org>  Mon, 24 Nov 2025 08:21:12 +0100

wlmaker (0.6.2-1) unstable; urgency=medium

  * New upstream version.
  * d/control:
    - dropped Rules-Requires-Root.
    - add libwlroots-0.18-dev to build-depends.
  * d/rules: dropped configure parameters.

 -- Alex Myczko <tar@debian.org>  Sun, 23 Nov 2025 21:03:45 +0100

wlmaker (0.6.1+git20250919+ds-4) unstable; urgency=medium

  * d/rules: fix type, BUILD_TESTING.

 -- Alex Myczko <tar@debian.org>  Wed, 19 Nov 2025 19:18:01 +0100

wlmaker (0.6.1+git20250919+ds-3) unstable; urgency=medium

  * d/rules: disable build tests.
  * d/watch: update to version 5.

 -- Alex Myczko <tar@debian.org>  Wed, 19 Nov 2025 12:56:57 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,6 @@
 Priority: optional
 Maintainer: Debian GNUstep maintainers <pkg-gnustep-maintainers@lists.alioth.debian.org>
 Uploaders: Alex Myczko <tar@debian.org>
-Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
  bison,
@@ -12,7 +11,7 @@
  libwayland-dev,
  libcairo2-dev,
  wayland-protocols,
- libwlroots-0.19-dev,
+ libwlroots-0.18-dev,
  libncurses-dev,
 # plantuml,
  libwayland-bin,
